
from paraview.simple import *
from paraview import coprocessing


#--------------------------------------------------------------
# Code generated from cpstate.py to create the CoProcessor.
# ParaView 5.0.0 64 bits


# ----------------------- CoProcessor definition -----------------------

def CreateCoProcessor():
  def _CreatePipeline(coprocessor, datadescription):
    class Pipeline:
      # state file generated using paraview version 5.0.0

      # ----------------------------------------------------------------
      # setup the data processing pipelines
      # ----------------------------------------------------------------

      #### disable automatic camera reset on 'Show'
      paraview.simple._DisableFirstRenderCameraReset()

      # create a new 'EnSight Reader'
      # create a producer from a simulation input
      rESULTScase = coprocessor.CreateProducer(datadescription, 'input')

      # create a new 'Cell Data to Point Data'
      cellstopoints = CellDatatoPointData(Input=rESULTScase)

      # create a new 'Extract Block'
      fluiddomain = ExtractBlock(Input=cellstopoints)
      fluiddomain.BlockIndices = [1]

      # create a new 'Calculator'
      velMag = Calculator(Input=fluiddomain)
      velMag.ResultArrayName = 'VelMag'
      velMag.Function = 'mag(Velocity)'

      # create a new 'Threshold'
      threshold = Threshold(Input=velMag)
      threshold.Scalars = ['POINTS', 'VelMag']
      threshold.ThresholdRange = [40.0, 10000.0]

      # create a new 'Slice'
      sliceVerCnt = Slice(Input=fluiddomain)
      sliceVerCnt.SliceType = 'Plane'
      sliceVerCnt.SliceOffsetValues = [0.0]

      # init the 'Plane' selected for 'SliceType'
      sliceVerCnt.SliceType.Origin = [-2.8999999999999999, -0.09176933765411377, 0.13777470588684082]

      # create a new 'Surface Vectors'
      surfaceVectors = SurfaceVectors(Input=sliceVerCnt)
      surfaceVectors.SelectInputVectors = ['POINTS', 'Velocity']

      # create a new 'Glyph'
      velVectors = Glyph(Input=surfaceVectors,
          GlyphType='Arrow')
      velVectors.Scalars = ['POINTS', 'parallel_domain']
      velVectors.Vectors = ['POINTS', 'Velocity']
      velVectors.ScaleFactor = 0.10000000000000001
      velVectors.GlyphTransform = 'Transform2'

      # create a new 'Probe Location'
      probeSliceVer = ProbeLocation(Input=sliceVerCnt,
          ProbeType='Fixed Radius Point Source')
      probeSliceVer.Tolerance = 2.2204460492503101e-16

      # init the 'Fixed Radius Point Source' selected for 'ProbeType'
      probeSliceVer.ProbeType.Center = [-2.9000000953674316, 0.32797705637384333, -0.24135379030495813]
    return Pipeline()

  class CoProcessor(coprocessing.CoProcessor):
    def CreatePipeline(self, datadescription):
      self.Pipeline = _CreatePipeline(self, datadescription)

  coprocessor = CoProcessor()
  # these are the frequencies at which the coprocessor updates.
  freqs = {'input': []}
  coprocessor.SetUpdateFrequencies(freqs)
  return coprocessor

#--------------------------------------------------------------
# Global variables that will hold the pipeline for each timestep
# Creating the CoProcessor object, doesn't actually create the ParaView pipeline.
# It will be automatically setup when coprocessor.UpdateProducers() is called the
# first time.
coprocessor = CreateCoProcessor()

#--------------------------------------------------------------
# Enable Live-Visualizaton with ParaView
coprocessor.EnableLiveVisualization(True, 1)


# ---------------------- Data Selection method ----------------------

def RequestDataDescription(datadescription):
    "Callback to populate the request for current timestep"
    global coprocessor
    if datadescription.GetForceOutput() == True:
        # We are just going to request all fields and meshes from the simulation
        # code/adaptor.
        for i in range(datadescription.GetNumberOfInputDescriptions()):
            datadescription.GetInputDescription(i).AllFieldsOn()
            datadescription.GetInputDescription(i).GenerateMeshOn()
        return

    # setup requests for all inputs based on the requirements of the
    # pipeline.
    coprocessor.LoadRequestedData(datadescription)

# ------------------------ Processing method ------------------------

def DoCoProcessing(datadescription):
    "Callback to do co-processing for current timestep"
    global coprocessor

    # Update the coprocessor by providing it the newly generated simulation data.
    # If the pipeline hasn't been setup yet, this will setup the pipeline.
    coprocessor.UpdateProducers(datadescription)

    # Write output data, if appropriate.
    coprocessor.WriteData(datadescription);

    # Write image capture (Last arg: rescale lookup table), if appropriate.
    coprocessor.WriteImages(datadescription, rescale_lookuptable=False)

    # Live Visualization, if enabled.
    coprocessor.DoLiveVisualization(datadescription, "localhost", 22222)
